package de.privacynerd.chatbeautifier;

import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.text.format.TextDecoration;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;


public class JoinQuitListener implements Listener {

    @EventHandler
    public void onPlayerJoin(PlayerJoinEvent event) {
        Player player = event.getPlayer();
        Component newName;

        if(player.isOp()) {
            newName = Component.text("[OP] ")
                    .color(NamedTextColor.RED)
                    .decoration(TextDecoration.BOLD, true)
                    .append(Component.text(player.getName())
                            .color(NamedTextColor.GRAY)
                            .decoration(TextDecoration.BOLD, false)
                    );
            player.displayName(newName);
            player.playerListName(newName);
        } else {
            newName = Component.text(player.getName())
                    .color(NamedTextColor.GRAY)
                    .decoration(TextDecoration.BOLD, false);
            player.displayName(newName);
            player.playerListName(newName);
        }

        event.joinMessage(Component.text(">> ")
                .color(NamedTextColor.GREEN)
                .decoration(TextDecoration.BOLD, true)
                .append(player.displayName()
                ));
        player.playSound(player.getLocation(), Sound.AMBIENT_CRIMSON_FOREST_MOOD, 0.5f, 0.4f);
    }


    @EventHandler
    public void onPlayerQuit(PlayerQuitEvent event) {
        Player player = event.getPlayer();
        Component displayName = player.displayName();

        event.quitMessage(Component.text("<< ")
                .color(NamedTextColor.RED)
                .decoration(TextDecoration.BOLD, true)
                .append(displayName));
    }
}
